DECLARE SUB put.book (nimi$, t%, dam$)
DECLARE SUB createpotions ()
DECLARE SUB createarmors ()
DECLARE SUB createbooks ()
DECLARE SUB createweapons ()
'luodaan esinedata
DECLARE SUB put.weapon (nimi$, acp%, r%, dam$)

DIM SHARED n AS STRING * 20, d AS STRING * 6
DIM SHARED delay.time AS LONG

ON TIMER(1) GOSUB speeddone

TIMER ON

speedtest = 0: delay.time = 0

CLS
PRINT STRING$(12, ".") + "QWORLD SETUP" + STRING$(12, ".")
PRINT "Performing speed-up-test...";

WHILE speedtest = 0
  delay.time = delay.time + 1
WEND
DIM delayt AS INTEGER
delayt = (delay.time / 100) 'yksi sadasosasekunti
TIMER OFF

PRINT "OK"
PRINT "Creating data.dat...";
OPEN "data.dat" FOR BINARY AS #1
  PUT #1, , delayt
CLOSE #1
PRINT "OK"
PRINT "       Creating items.dat"
OPEN "items.dat" FOR BINARY AS #1
  CALL createweapons
  CALL createbooks
  CALL createpotions
  CALL createarmors
CLOSE #1
PRINT "       OK"

PRINT "Setup done. Press a key to run QWORLD..."
DO: LOOP WHILE INKEY$ = ""

RUN "crfield.bas"

speeddone:
  speedtest = 1
RETURN

SUB createarmors
  PRINT "Performing shelter creation...";
    'armorit
    'nimi, defense, tyhj
    put.book "Leather coat", 1, ""
    put.book "Plate leather", 2, ""
    put.book "Hard plate leather", 3, ""
    put.book "Guirass", 6, ""
    put.book "Ring mail", 10, ""
    put.book "Plate ring mail", 12, ""
    put.book "Plate mail", 16, ""
    put.book "Full plate mail", 20, ""
    'kilvet
    put.book "Wooden shield", 1, ""
    put.book "Buckler", 2, ""  'joku metallikilpi
    put.book "Large shield", 4, ""
    put.book "Larger shield", 7, ""
    put.book "Plate shield", 10, ""
    put.book "Kite shield", 12, ""
    put.book "Lesser tower shield", 13, ""
    put.book "Tower shield", 15, ""

    'kyprt
    put.book "Leather cap", 1, ""
    put.book "Cap", 2, ""
    put.book "Lesser helm", 5, ""
    put.book "Crown", 8, ""
    put.book "Helm", 11, ""
    put.book "Mask", 12, ""
    put.book "Full helm", 13, ""
    put.book "Horned helmet", 15, ""

  PRINT "OK"
END SUB

SUB createbooks
  PRINT "Performing spell & books creation...";
  'itse asiassa nimi on loitsun nimi. numerolla ei tee mitn.
  'nimi, iip, damage (xdy+c)
  put.book "Fire Bolt", 1, "2d2+2"
  put.book "Lighting", 2, "1d8"
  put.book "Poison Bolt", 3, "4d2+2"
  put.book "", 4, ""
  put.book "", 5, ""
  put.book "", 6, ""
  put.book "", 7, ""
  put.book "", 8, ""
  put.book "", 9, ""
  put.book "", 10, ""
  put.book "", 11, ""
  put.book "", 12, ""
  put.book "", 13, ""
  put.book "", 14, ""
  put.book "", 15, ""

  PRINT "OK"

END SUB

SUB createpotions
  PRINT "Performing potion creation...";

  put.book "Healing potion", 1, ""
  put.book "Mana restore potion", 2, ""
  put.book "Potion of Vision", 3, ""
  put.book "Ei-alustettu 1", 0, ""
  put.book "Ei-alustettu 2", 0, ""

  PRINT "OK"

END SUB

SUB createweapons
  PRINT "Performing weapons creation...";
  'mit "alempana" ase on, sit kalliimpi se on.
  put.weapon "Knive", 1, 1, "1d3"
  put.weapon "Club", 1, 1, "1d2+2"
  put.weapon "Sharp spike", 1, 1, "1d2+1"
  put.weapon "Dagger", 1, 1, "1d3+1"
  put.weapon "Hatchet", 2, 1, "1d3+2"
  put.weapon "Strong dagger", 1, 1, "2d2+1"
  put.weapon "One-hand axe", 1, 1, "2d3+1"
  put.weapon "Spiked Club", 1, 1, "1d3+2"
  put.weapon "Skull club", 2, 1, "1d2+4"
  put.weapon "Mace", 2, 1, "1d4+3"
 
  put.weapon "Short sword", 1, 1, "1d4+1"
  put.weapon "Maul", 3, 1, "2d4+2"
  put.weapon "Broadsword", 2, 1, "2d3+1"
  put.weapon "Scimitar", 2, 1, "1d6+1"
  put.weapon "Great maul", 3, 1, "2d5+3"
  put.weapon "Sling", 1, 5, "1d2"
  put.weapon "Stone club", 4, 1, "1d5+9"
  put.weapon "Long sword", 3, 1, "1d6+2"
  put.weapon "Flail", 2, 2, "1d4" 'ranged
  put.weapon "Brutal blade", 3, 1, "2d4+1"

  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""

  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "Too strong club", 7, 1, "6d9+14"
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""

  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""
  put.weapon "", 1, 1, ""

  PRINT "OK"
END SUB

SUB put.book (nimi$, t%, dam$)

  n = nimi$: d = dam$

  PUT #1, , n
  PUT #1, , t%
  PUT #1, , d

END SUB

SUB put.weapon (nimi$, acp%, r%, dam$)

  n = nimi$: d = dam$

  PUT #1, , n
  PUT #1, , acp%
  PUT #1, , r%
  PUT #1, , d

END SUB

