DECLARE SUB openbmp (filename$, drawit AS INTEGER)
DECLARE FUNCTION get.key$ ()
DECLARE FUNCTION getcolor% ()

DIM SHARED kuva(1 TO 202) AS INTEGER

DIM SHARED ylos$, alas$, vasen$, oikea$

ylos$ = CHR$(0) + CHR$(72)
alas$ = CHR$(0) + CHR$(80)
oikea$ = CHR$(0) + CHR$(77)
vasen$ = CHR$(0) + CHR$(75)

nimi$ = "goblin.pic"

SCREEN 13

'RANDOMIZE TIMER

openbmp "goblin.bmp", 1



'FOR x% = 0 TO 19
'FOR y% = 0 TO 19
'  SELECT CASE INT(RND * 3)
'    CASE 0: PSET (x%, y%), 117 + INT(RND * 6)
'    CASE 1: PSET (x%, y%), 2 + INT(RND * 2) * 8
'    CASE 2: PSET (x%, y%), 48 + INT(RND * 4)
'  END SELECT
'NEXT y%, x%

GET (0, 0)-(19, 19), kuva

DEF SEG = VARSEG(kuva(1))
'BSAVE nimi$, VARPTR(kuva(1)), 404'68

DEF SEG = VARSEG(kuva(1))
BLOAD nimi$, VARPTR(kuva(1))

PUT (100, 100), kuva

END

SUB draw.pic
x% = 0: y% = 0: c% = 2
DO
  k$ = get.key$
  IF k$ = ylos$ AND y% > 0 THEN
    y% = y% - 1
  ELSEIF k$ = alas$ AND y% < 19 THEN
    y% = y% + 1
  ELSEIF k$ = vasen$ AND x% > 0 THEN
    x% = x% - 1
  ELSEIF k$ = oikea$ AND x% < 19 THEN
    x% = x% + 1
  ELSEIF k$ = CHR$(13) THEN
    PSET (x%, y%), c%
  ELSEIF k$ = "c" OR k$ = "C" THEN
    c% = getcolor
  ELSEIF k$ = CHR$(27) THEN
    EXIT DO
  END IF
LOOP

END SUB

FUNCTION get.key$
  k$ = ""
  DO
    k$ = INKEY$
  LOOP UNTIL k$ <> ""
  get.key$ = k$
END FUNCTION

FUNCTION getcolor%
  FOR r% = 0 TO 160
    LINE (r% * 2, 160)-(r% * 2 + 1, 161), r%, B
  NEXT
  r% = 2
  DO
    LINE (r% * 2, 158)-(r% * 2 + 1, 159), r%, B
    k$ = get.key$
    LINE (r% * 2, 158)-(r% * 2 + 1, 159), 0, B
    IF k$ = vasen$ AND r% > 0 THEN
      r% = r% - 1
    ELSEIF k$ = oikea$ AND r% < 160 THEN
      r% = r% + 1
    ELSEIF k$ = CHR$(13) THEN
      EXIT DO
    END IF
  LOOP
  getcolor% = r%
END FUNCTION

SUB openbmp (filename$, drawit AS INTEGER)

'bittikartan lataaja - piirt mokoman - (c) Tarmo Korpela
DIM x AS SINGLE, y AS SINGLE, p1 AS INTEGER

OPEN filename$ FOR BINARY AS #1

header$ = SPACE$(14)
sizing$ = SPACE$(4)
GET #1, 1, header$ 'headeri
GET #1, 15, sizing$ 'kokoluokittelu
bmpinfosize = CVI(sizing$) 'paljonko infoa
IF bmpinfosize = 12 THEN '12 tavua
   infoheader$ = SPACE$(12)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))

   IF nbits = 1 THEN       '1-vrinen
      palet$ = SPACE$(6)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN   '16 vri
      palet$ = SPACE$(48)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN   '256
      palet$ = SPACE$(768)
      GET #1, bmpinfosize + 15, palet$
   END IF
ELSEIF bmpinfosize = 40 THEN '40 tavua
   infoheader$ = SPACE$(40)
   GET #1, 15, infoheader$
   nbits = CVI(MID$(infoheader$, 15, 4))
   IF nbits = 1 THEN   '1-vrinen
      palet$ = SPACE$(8)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 4 THEN  '16
      palet$ = SPACE$(64)
      GET #1, bmpinfosize + 15, palet$
   ELSEIF nbits = 8 THEN  '256
      palet$ = SPACE$(1024)
      GET #1, bmpinfosize + 15, palet$
   END IF
END IF


ft$ = MID$(header$, 1, 2)

filesize = CVL(MID$(header$, 3, 4)) 'tiedoston koko

r1 = CVI(MID$(header$, 7, 2))

r2 = CVI(MID$(header$, 9, 2))

offset = CVL(MID$(header$, 11, 4))


headersize = CVL(MID$(infoheader$, 1, 4))

picwidth = CVL(MID$(infoheader$, 5, 4))

picheight = CVL(MID$(infoheader$, 9, 4))

nplanes = CVI(MID$(infoheader$, 13, 4))


IF headersize = 40 THEN
   comptype = CVL(MID$(infoheader$, 17, 4))

   imagesize = CVL(MID$(infoheader$, 21, 4))

   xsize = CVL(MID$(infoheader$, 25, 4))

   ysize = CVL(MID$(infoheader$, 29, 4))
  
   colorsused = CVL(MID$(infoheader$, 33, 4))

   neededcolours = CVL(MID$(infoheader$, 37, 4))
END IF

IF nbits = 1 THEN
   SCREEN 11
ELSEIF nbits = 4 THEN
   SCREEN 12
ELSEIF nbits = 8 OR nbits = 24 THEN
   SCREEN 13
END IF

'LOCATE 1, 40: PRINT "Loading Palette..."
IF bmpinfosize = 40 THEN ngroups = 4
IF bmpinfosize = 12 THEN ngroups = 3

IF nbits = 24 THEN
   IF ngroups = 3 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d)
      NEXT c
   ELSEIF ngroups = 4 THEN
      FOR c = 0 TO 63
         d = c * 4
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d) + CHR$(d + 1) + CHR$(0)
         palet$ = palet$ + CHR$(d) + CHR$(d + 1) + CHR$(d) + CHR$(0)
         palet$ = palet$ + CHR$(d + 1) + CHR$(d) + CHR$(d) + CHR$(0)
      NEXT c
   END IF
END IF

FOR x = 1 TO LEN(palet$) STEP ngroups
   zb# = INT((ASC(MID$(palet$, x, 1))) / 4)
   zg# = INT((ASC(MID$(palet$, x + 1, 1))) / 4)
   zr# = INT((ASC(MID$(palet$, x + 2, 1))) / 4)
   zc# = zb# * 65536# + zg# * 256# + zr#
   cres = ASC(MID$(palet$, x + 3, 1))
   PALETTE ((x - 1) / ngroups), zc#
NEXT x

'piirretn kuva
p1 = 0
IF drawit = 1 THEN
  IF nbits = 24 THEN
    y = picheight - 1
    x = 0
    dat$ = "   "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        p1 = INT(((ASC(MID$(dat$, 1, 1)) + ASC(MID$(dat$, 1, 1)) + ASC(MID$(dat$, 1, 1))) / 3))
        PSET (x, y), p1
        x = x + 1
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 8 THEN
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET #1, , dat$
        p1 = ASC(dat$)
        PSET (x, y), p1
        x = x + 1
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 4 THEN '16 vri
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        LOCATE 1, 1
        p1 = ASC(dat$) AND 15
        p2 = ASC(dat$) AND 240 / 16
        PSET (x, y), p1: PSET (x + 1, y), p2
        x = x + 2
      WEND
      y = y - 1
      x = 0
    WEND
  ELSEIF nbits = 1 THEN
    y = picheight - 1
    x = 0
    dat$ = " "
    WHILE y >= 0
      WHILE x < picwidth
        GET 1, , dat$
        p1 = ASC(dat$)
        p3 = 1
        FOR p = 0 TO 7
          p2 = ABS((p1 AND p3) <> 0)    '1 jos tosi, 0 jos ei
          PSET (x, y), p2
          p3 = p3 * 2   'muutetaan
          x = x + 1
        NEXT p
      WEND
      y = y - 1
      x = 0
    WEND
  END IF
END IF

CLOSE #1


END SUB

